
' Program written by Marti Minoves
' This program is free to use with a licence of GPL but for modification it is only needed to notify the author.



' This program does the following:
'  -For all the internet connections it performs, it emulates exactly the Pocket Internet Explorer, in this way it is compatible to all Wap Flat rates like the o2flat from Germany, or o2 flat rate from UK.
'  -It sets itself to autostart the following day at updateTime, and also at middayStart and nightStart
'   (at updateTime (the first run of the day) is when it sets the autostarts for the following day)
'  -Once every EphemerisDaysToWait it downloads the file from URLephemeris and copies it to FILEephemeris 
'  -Once per day, at updateTime, it updates form internet the files FILEaccuweather from URLaccuweather, and FILEwettercom from URLwettercom
'  -Once per day, at updateTime, it updates the HTCtoday plugin with information from FILEaccuweather
'  -Three times per day,at updateTime, at nightStart and at nightStart, it updates the HTCtoday Title with information from the file FILEwettercom
'  -Three times per day,at updateTime, at nightStart and at nightStart, it also updates the registry registerKey1/registerKey2 with the information taken from the file FILEwettercomToRead
'   (this is usefull for example to update the weather information from the program Slide2Unlock)
'  -It updates the registerKey1/registerKey2Userdata with the value registerKey2UserdataValue
'  -It also sets to autostart the program FILEprogramToStart to start at updateTime before updating from the files
'  -If you want more information about weather you can open locally with the pocket Internet Explorer the file FILEwettercom, and if you have the icons in the same folder you will also see the prediccions graphically (add the file to favorites or create a shortcut to the FILEwettercom


' Personalization:
' You can run only the functions of this program that you want by not setting any value in the .ini file
'   For example is if you want to use this program only to update automatically the Ephemeris you can delete the values of the URL in the .ini file.


' Program Parameters:
'   /deactivate   Eliminates the autostarts of this program.
'   /onlyupdate (or any other parameter) It works offline, updates only with the local files

' Notes:
'  Sorry I didn't translate from Catalan to English all the comments of this program! 
'  If you get a WebException error, it is probably that your device is not connected correctly to internet or that you specified the URL wrong in the .ini file. Open them with your normal Explorer to check if they can open.
'  If you cannot open the MMeteo.exe download the Microsoft .NET Compact Framework http://www.microsoft.com/downloads/details.aspx?familyid=9655156b-356b-4a2c-857c-e62f50ae9a55&displaylang=en

'Installation:
'  Edit the file MMeteo.ini and enter the URL of your city. Read instructions there if you want to personalize / change functions.
'  Copy MMeteo.exe and MMeteo.ini to your pda (usually at \MMeteo.exe and \MMeteo.ini)
'  OPTIONAL: Copy the folder with the icons if you want to open the generated .html locally without an internet connection (ex. for german devices at \Speicherkarte\MMeteo\)
'  OPTIONAL: If you want, create a link in the Start Menu to open the file wettercom.htm (an example of this link is included, named: MMeteoWettercom.htm.lnk)
'  Start the program MMeteo.exe





Imports System
Imports Microsoft.Win32
Imports System.Runtime.InteropServices

Imports System.Net
Imports System.IO
Imports System.Text

Imports System.Xml


Module Module1

    Dim FILEconfig As String = ".\MMeteo.ini"

    'INICIAL CONFIGURATION (THEN IT IS LOADED FROM THE INI FILE):****************************************************

    Dim registerKey1 As String = "HKEY_CURRENT_USER\Software\A_C\Slide2Unlock"
    Dim registerKey2 As String = "UserWeather"
    Dim registerKey2Userdata As String = "ShowWeather"
    Dim registerKey2UserdataValue As String = "4"


    Dim updateTime As Int16 = 7 'hour of the day to start the update

    Dim middayStart As Int16 = 10 ' hour of the day considered to be the midday start
    Dim nightStart As Int16 = 17 ' hour of the day considered to be the night start


    Dim FILEprogramToStart As String = ""   ' "\MeteoSlideCmd2Prog.lnk"
    Dim FILEthisProgram As String = "\MMeteo.exe"


    ' Dim FILEthisProgramOnlyUpdate As String = "\MMeteo.exe /onlyupdate"  ' "\MeteoSlideCmd2OnlyUpdate.lnk"

    Dim URLaccuweather As String = "http://htc.accuweather.com/widget/htc/forecast-data_v3.asp?ac=TR2cra9U&locCode="
    Dim FILEaccuweather As String = "\Speicherkarte\MMeteo\accuweather.xml"
    Dim AccuWeatherCity As String = ""

    Dim URLwettercom As String = "http://www.wetter.com/mobile/wetter.php?id=27024&type=WORLD"
    Dim URLwettercomFiltered As String = ""
    Dim FILEwettercom As String = "\Speicherkarte\MMeteo\wettercom.htm"
    'Const FILEfrompRSSreader As String = "\Speicherkarte\Programme\pRSSreader\Cache\Temps.xml"
    Dim FILEwettercomToRead As String = FILEwettercom

    Dim URLephemeris As String = "http://service.mio-tech.com/eeservice/packedephemeris.ee"
    Dim FILEephemeris As String = "\windows\packedephemeris.ee"
    Dim EphemerisDaysToWait As Int16 = 2



    Dim HTCregisterKey1 As String = "HKEY_LOCAL_MACHINE\Software\HTC\HTCHome\Weather"


    'END OF CONFIGURATION**********************************************

    Public Class SystemTime
        Public wYear As Short
        Public wMonth As Short
        Public wDayOfWeek As Short
        Public wDay As Short
        Public wHour As Short
        Public wMinute As Short
        Public wSecond As Short
        Public wMiliseconds As Short
    End Class


    Private Sub talla(ByRef s As String, ByVal tall As String)

        Dim posicio As Integer = InStr(s, tall)
        s = Mid(s, posicio + Len(tall))
    End Sub

    Private Function valorEntreFragments(ByRef s As String, ByVal fragment1 As String, ByVal fragment2 As String) As String
        If s = "" Then MsgBox("Error: Text to search on incorrect!")
        Dim posicio1 As Integer = InStr(s, fragment1)
        If posicio1 <= 0 Then MsgBox("Error: Cannot find " & fragment1 & " in the text.")
        Dim posicio2 As Integer = InStr(posicio1 + Len(fragment1), s, fragment2)
        If posicio1 <= 0 Then MsgBox("Error: Cannot find " & fragment2 & " in the text.")

        Dim longitud As Integer = posicio2 - posicio1 - Len(fragment1)
        If longitud < 0 Then MsgBox("Error: Text Fragments incorrect. Fragment1:" & fragment1 & " Fragment2:" & fragment2)
        valorEntreFragments = Mid(s, posicio1 + Len(fragment1), longitud)

    End Function

    Declare Function CeRunAppAtTime Lib "coredll.dll" ( _
                             ByVal pwszAppName As String, _
                             ByVal lpTime As SystemTime) As Boolean


    '' Per despertar el Pocketpc:
    'Declare Function SetSystemPowerState Lib "coredll.dll" ( _
    'ByVal psState As String, _
    'ByVal StateFlags As Integer, _
    'ByVal Options As Integer) As Integer


    Public Sub SetAppStartProg() 'no uso aquesta funcio ara

        If (FILEprogramToStart = "") Then Exit Sub

        Dim sysTime As New SystemTime



        Dim CurrDatTim As Date = Now   ' Current date and time.
        Dim LastMidnight As Date = CurrDatTim.Date   ' At midnight.

        LastMidnight = LastMidnight.AddDays(1) 'Tomorrow
        'LastMidnight.AddHours(7)

        'temp:
        ' LastMidnight = Now


        With sysTime
            .wDay = LastMidnight.Day
            '.wDayOfWeek = 6
            .wHour = updateTime
            .wMiliseconds = 0
            .wMinute = 0
            .wMonth = LastMidnight.Month
            .wSecond = 0
            .wYear = LastMidnight.Year
        End With

        CeRunAppAtTime(FILEprogramToStart, sysTime)
    End Sub


    Public Sub SetAppStartSelfDelete()
        CeRunAppAtTime(FILEthisProgram, Nothing)

        Dim LastMidnight As Date = Now.Date   ' At midnight.

        CeRunAppAtTime(Chr(34) & FILEthisProgram & Chr(34) & " /midday" & LastMidnight.Day, Nothing)
        CeRunAppAtTime(Chr(34) & FILEthisProgram & Chr(34) & " /night" & LastMidnight.Day, Nothing)

        LastMidnight = LastMidnight.AddDays(1)
        CeRunAppAtTime(Chr(34) & FILEthisProgram & Chr(34) & " /midday" & LastMidnight.Day, Nothing)
        CeRunAppAtTime(Chr(34) & FILEthisProgram & Chr(34) & " /night" & LastMidnight.Day, Nothing)
    End Sub


    Public Sub SetAppStartSelf()

        Dim sysTime As New SystemTime



        Dim CurrDatTim As Date = Now   ' Current date and time.
        Dim LastMidnight As Date = CurrDatTim.Date   ' At midnight.

        LastMidnight = LastMidnight.AddDays(1) 'Tomorrow
        'LastMidnight.AddHours(7)

        'temp:
        ' LastMidnight = Now



        With sysTime
            .wDay = LastMidnight.Day
            '.wDayOfWeek = 6
            .wHour = updateTime
            .wMiliseconds = 0
            .wMinute = 4  'pq espera a que acabi el programa pRSSreader executat a les X:00
            .wMonth = LastMidnight.Month
            .wSecond = 0
            .wYear = LastMidnight.Year
        End With

        CeRunAppAtTime(FILEthisProgram, sysTime)


        With sysTime
            .wDay = LastMidnight.Day
            '.wDayOfWeek = 6
            .wHour = middayStart
            .wMiliseconds = 0
            .wMinute = 5  'aix asegurem que actualitzar a la seguent franja hoaria
            .wMonth = LastMidnight.Month
            .wSecond = 0
            .wYear = LastMidnight.Year
        End With

        CeRunAppAtTime(Chr(34) & FILEthisProgram & Chr(34) & " /midday" & LastMidnight.Day, sysTime)



        ' el argument /migdia i /nit son noms introduir dos entrades que executen el mateix i semblen diferents
        ' si no, al posar la segona elimina la primera
        ' A ms afegeixo el dia perqu si no el primer cop del dia eliminaria les dues execucions restants del mateix dia ja que estableix el seguent dia

        With sysTime
            .wDay = LastMidnight.Day
            '.wDayOfWeek = 6
            .wHour = nightStart
            .wMiliseconds = 0
            .wMinute = 5  'aix asegurem que actualitzar a la seguent franja hoaria
            .wMonth = LastMidnight.Month
            .wSecond = 0
            .wYear = LastMidnight.Year
        End With

        CeRunAppAtTime(Chr(34) & FILEthisProgram & Chr(34) & " /night" & LastMidnight.Day, sysTime)


    End Sub



    Private Sub descarregar(ByVal curl As String, ByVal fitxer As String)

        '    End Sub
        '   Private Sub descarregar2(ByVal curl As String, ByVal fitxer As String)


        'Dim curl As String = "http://maps.weather.com/web/radar/us_orl_ultraradar_large_usen.jpg"
        'Dim fitxer As String = "\Speicherkarte\weather.jpg"

        'curl = curl + "?param1=" + CStr(DateTime.UtcNow) ' just to double sure that data coming is fresh :)
        Dim creq As WebRequest
        Dim cresult As WebResponse
        Dim cReceiveStream As Stream


        'Try
        creq = WebRequest.Create(curl)
        'creq.Headers.Add("Accept-Encoding: gzip")


        creq.Headers.Add("UserAgent", "HTC_P4550 Mozilla/4.0 (compatible; MSIE 6.0; Windows CE; IEMobile 7.7)")
        'creq.Headers.Add("Accept", "*/*")  'RESTRINGIT PER LA API- NO ES POT MODIFICAR
        creq.Headers.Add("Accept-Language", "de")
        creq.Headers.Add("Pragma", "no-cache")
        creq.Headers.Add("Ua-Color", "color16")
        creq.Headers.Add("Ua-Cpu", "ARM")
        creq.Headers.Add("Ua-Os", "Windows CE (Pocket PC) - Version 5.2")
        creq.Headers.Add("Ua-Pixels", "240x320")
        creq.Headers.Add("Ua-Voice", "TRUE")
        creq.Headers.Add("X-Wap-Profile", "\" & Chr(34) & "http://www.htcmms.com.tw/gen/Artemis-1.0.xml\" & Chr(34))
        'creq.Headers.Remove("Accept-Encoding")
        'creq.Headers.Remove("Accept-Charset")
        'creq.Headers.Remove("Keep-Alive")
        'creq.Headers.Remove("Connection")


        cresult = creq.GetResponse()

        'Catch ex As Exception

        'End Try

        cReceiveStream = cresult.GetResponseStream()
        'Dim str As Stream = ws.GetResponseStream()

        Dim inBuf(100000) As Byte
        Dim bytesToRead As Integer = CInt(inBuf.Length)
        Dim bytesRead As Integer = 0
        While bytesToRead > 0
            Dim n As Integer = cReceiveStream.Read(inBuf, bytesRead, bytesToRead)
            If n = 0 Then
                Exit While
            End If
            bytesRead += n
            bytesToRead -= n
        End While
        Dim fstr As New FileStream(fitxer, FileMode.Create, FileAccess.Write)  'FileMode.OpenOrCreate no es correcte!!
        fstr.Write(inBuf, 0, bytesRead)
        cReceiveStream.Close()
        fstr.Close()





        ''''''''
        'Dim gz As New GZip.GZipInputStream(cresult.GetResponseStream)
        'Dim buf(50000) As Byte
        'gz.Read(buf, 0, 49000)
        'Dim ii As Integer = 0
        'While (True) ' checking how many bytes occupied
        '    If CStr(buf(ii)) = "0" Then
        '        Exit While
        '    End If
        '    ii += 1
        'End While
        'Dim csr As New StreamReader(New MemoryStream(buf, 0, ii)) ' its all yours now,just deal with csr




        ''''''''''''''''

        'antic:  Dim wr As HttpWebRequest = CType(WebRequestFactory.Create("http://maps.weather.com/web/radar/us_orl_ultraradar_large_usen.jpg"), HttpWebRequest)
        'Dim wr As HttpWebRequest = CType(WebRequest.Create("http://maps.weather.com/web/radar/us_orl_ultraradar_large_usen.jpg"), HttpWebRequest)

        'wr.UserAgent = "HTC_P4550 Mozilla/4.0 (compatible; MSIE 6.0; Windows CE; IEMobile 7.7)"
        'wr.Accept = "*/*"
        'wr.Headers.Set("Accept-Language", "de")
        'wr.Headers.Set("Pragma", "no-cache")
        'wr.Headers.Set("Ua-Color", "color16")
        'wr.Headers.Set("Ua-Cpu", "ARM")
        'wr.Headers.Set("Ua-Os", "Windows CE (Pocket PC) - Version 5.2")
        'wr.Headers.Set("Ua-Pixels", "240x320")
        'wr.Headers.Set("Ua-Voice", "TRUE")
        'wr.Headers.Set("X-Wap-Profile", "\" & Chr(34) & "http://www.htcmms.com.tw/gen/Artemis-1.0.xml\" & Chr(34))
        'wr.Headers.Remove("Accept-Encoding")
        'wr.Headers.Remove("Accept-Charset")
        'wr.Headers.Remove("Keep-Alive")
        'wr.Headers.Remove("Connection")



        'Dim ws As HttpWebResponse = CType(wr.GetResponse(), HttpWebResponse)
        'Dim str As Stream = ws.GetResponseStream()
        'Dim inBuf(100000) As Byte
        'Dim bytesToRead As Integer = CInt(inBuf.Length)
        'Dim bytesRead As Integer = 0
        'While bytesToRead > 0
        '    Dim n As Integer = str.Read(inBuf, bytesRead, bytesToRead)
        '    If n = 0 Then
        '        Exit While
        '    End If
        '    bytesRead += n
        '    bytesToRead -= n
        'End While
        'Dim fstr As New FileStream("\Speicherkarte\weather.jpg", FileMode.OpenOrCreate, FileAccess.Write)
        'fstr.Write(inBuf, 0, bytesRead)
        'str.Close()
        'fstr.Close()

        '''''''''''''


        ' System.Uri.UriSchemeHttp
        ' <ComVisibleAttribute(False)> Public MustInherit Class HttpWorkerRequest
        'Dim instance As System.web.HttpWorkerRequest
        'Dim instance As New HttpWorkerRequest

        '''''''''''
        'Dim fileName As String = "Response.txt"
        'Dim myStringWebResource As String = Nothing
        'Dim myWebClient As New webcliWebClient
        'Try
        '    myStringWebResource = "http://www.xxxx.net"
        '    myWebClient.DownloadFile(myStringWebResource, "Response.txt")
        '    TextBox2.Text = "Successfully Downloaded file " + myStringWebResource
        '    TextBox2.Text = TextBox2.Text + ControlChars.NewLine + ControlChars.NewLine + "Downloaded file saved in the following file system folder:" + ControlChars.NewLine + ControlChars.Cr + Application.StartupPath + "\Response.txt" + ControlChars.Cr
        'Catch ex As Exception
        '    TextBox2.Text = "Error Occured" + ControlChars.Cr
        '    TextBox2.Text = TextBox2.Text + ex.Source + ControlChars.Cr
        '    TextBox2.Text = TextBox2.Text + ex.Message + ControlChars.Cr
        'End Try


        '      Dim httpRequest As HttpWebRequest
        '      httpRequest.Headers.Add("", "")
        '      httpRequest.EndGetResponse(




        'Dim userAgent As String
        'userAgent = Request.UserAgent
        'If userAgent.IndexOf("MSIE 6.0") > -1 Then
        '    ' The browser is Microsoft Internet Explorer 6.0.
        'End If
    End Sub


    Private Sub loadGlobals()
        Dim s As String = ""

        Try
            ' Open the file to read from.
            Dim sr As System.IO.StreamReader = System.IO.File.OpenText(FILEconfig)

            s = sr.ReadToEnd()
            sr.Close()
        Catch ex As Exception
            Beep()
            MsgBox("Error: I cannot load the file " & FILEconfig)
        End Try

        registerKey1 = valorEntreFragments(s, "registerKey1=", ";")
        registerKey2 = valorEntreFragments(s, "registerKey2=", ";")
        registerKey2Userdata = valorEntreFragments(s, "registerKey2Userdata=", ";")
        registerKey2UserdataValue = valorEntreFragments(s, "registerKey2UserdataValue=", ";")

        middayStart = Val(valorEntreFragments(s, "middayStart=", ";")) ' hour of the day considered to be the midday start
        nightStart = Val(valorEntreFragments(s, "nightStart=", ";")) ' hour of the day considered to be the night start

        updateTime = Val(valorEntreFragments(s, "updateTime=", ";")) 'hour of the day to start the update


        FILEprogramToStart = valorEntreFragments(s, "FILEprogramToStart=", ";")
        FILEthisProgram = valorEntreFragments(s, "FILEthisProgram=", ";")
        'FILEthisProgramOnlyUpdate = valorEntreFragments(s, "FILEthisProgramOnlyUpdate=", ";")

        URLaccuweather = valorEntreFragments(s, "URLaccuweather=", ";")
        FILEaccuweather = valorEntreFragments(s, "FILEaccuweather=", ";")
        AccuWeatherCity = valorEntreFragments(s, "AccuWeatherCity=", ";")

        URLwettercom = valorEntreFragments(s, "URLwettercom=", ";")
        URLwettercomFiltered = valorEntreFragments(s, "URLwettercomFiltered=", ";")
        FILEwettercom = valorEntreFragments(s, "FILEwettercom=", ";")
        'Const FILEfrompRSSreader As String = "\Speicherkarte\Programme\pRSSreader\Cache\Temps.xml"
        FILEwettercomToRead = valorEntreFragments(s, "FILEwettercomToRead=", ";")

        URLephemeris = valorEntreFragments(s, "URLephemeris=", ";")
        FILEephemeris = valorEntreFragments(s, "FILEephemeris=", ";")

        HTCregisterKey1 = valorEntreFragments(s, "HTCregisterKey1=", ";")


    End Sub


    Private Sub updateWeatherAllFromFileWettercom()
        If FILEwettercomToRead = "" Then Exit Sub


        Dim s As String = ""

        Try
            ' Open the file to read from.
            Dim sr As System.IO.StreamReader = System.IO.File.OpenText(FILEwettercomToRead)

            'Do While sr.Peek() >= 0
            's = sr.ReadLine()
            ''Console.WriteLine(s)
            '' s = Replace(s, Chr(13), Chr(13) & Chr(10))
            'TextBoxLlistat.Text = sr.ReadToEnd()
            '    TextBoxLlistat.Text = TextBoxLlistat.Text & Chr(10) & s
            'Loop

            s = sr.ReadToEnd()
            sr.Close()
        Catch ex As Exception
            Beep()
            MsgBox("Error: I cannot load the file " & FILEwettercomToRead)
        End Try

        Dim wettercomTitol As String

        If URLwettercomFiltered = "" Then
            wettercomTitol = filterWettercom(s)
            updateWeatherHTCfromFileWettercom(s, wettercomTitol)
        Else
            updateWeatherHTCfromFileWettercom(s)
        End If

        updateWeatherSlideFromFileWettercom(s)

    End Sub


    Private Function filterWettercom(ByRef s As String) As String
        talla(s, "Vorhersage")
        talla(s, "<table")
        s = valorEntreFragments(s, "</table>", "<!-- FORECAST END -->")

        s = Replace(s, "A HREF=/", "A HREF=http://www.wetter.com/mobile/")
        s = Replace(s, "src=" & Chr(34) & "..", "src=" & Chr(34) & "http://www.wetter.com")

        s = Replace(s, "http://www.wetter.com/v2/img/www/icons/wx/3/", "")
        s = Replace(s, "http://www.wetter.com/v2/img/www/", "")

        s = Replace(s, Chr(9), " ")  ' eliminates tabulators
        s = Replace(s, "  ", "") 'eliminatates double spaces

        Dim fragment1 As String = "line-height: 15px;" & Chr(34) & ">"
        Dim fragment2 As String = "<br>"

        Dim posicio1 As Integer = 1
        Dim posicio2 As Integer = 1
        Dim longitud As Integer
        Dim i As Int16
        Dim previsio(3) As String


        For i = 1 To 3
            posicio1 = InStr(posicio2, s, fragment1)
            posicio2 = InStr(posicio1 + Len(fragment1), s, fragment2)
            longitud = posicio2 - posicio1 - Len(fragment1)

            previsio(i) = Replace(Trim(Mid(s, posicio1 + Len(fragment1), longitud)), " ", "-")
        Next i

        filterWettercom = previsio(1) & " " & previsio(2) & " " & previsio(3) & "|"
        'filterWettercom = Replace(filterWettercom, Chr(9), "")  ' eliminates tabulators
        filterWettercom = Replace(filterWettercom, Chr(13), "")  ' eliminates changes of line
        filterWettercom = Replace(filterWettercom, Chr(10), "")  ' eliminates changes of line
    End Function



    Private Sub updateWeatherSlideFromFileWettercom(ByRef s As String)

        Dim value As String
        Dim icona As Integer
        Dim temperatura1 As String
        Dim temperatura2 As String


        Dim posicio As Integer
        Dim iconatexte As String
        posicio = InStr(s, "_b.gif")

        'Dim currentTime As Date
        'currentTime = TimeOfDay


        If (Now.Hour >= middayStart) Then
            s = Mid(s, posicio + 7) 'eliminem la primera part
            posicio = InStr(s, "_b.gif") 'Aix busquem la segona imatge que apareix, que s la imatge previsi d'avui al mig dia
        End If
        If (Now.Hour >= nightStart) Then
            s = Mid(s, posicio + 7) 'eliminem la primera part
            posicio = InStr(s, "_b.gif") 'Aix busquem la tercera imatge que apareix, que s la imatge previsi d'avui a la nit
        End If
        iconatexte = Mid(s, posicio - 4, 6)

        'en cas de tenir noms 5 caracters elimina el primer:
        If Mid(iconatexte, 1, 1) <> "d" And Mid(iconatexte, 1, 1) <> "n" Then
            iconatexte = Mid(iconatexte, 2)
        End If

        Select Case iconatexte
            Case "d_0_b"
                icona = 2

            Case "d_1_b"
                icona = 3
            Case "d_10_b"
                icona = 14
            Case "d_11_b"
                icona = 3
            Case "d_12_b"
                icona = 3
            Case "d_13_b"
                icona = 3
            Case "d_14_b"
                icona = 3
            Case "d_15_b"
                icona = 3
            Case "d_16_b"
                icona = 3
            Case "d_17_b"
                icona = 3
            Case "d_18_b"
                icona = 3
            Case "d_19_b"
                icona = 3

            Case "d_2_b"
                icona = 4
            Case "d_20_b"
                icona = 4
            Case "d_21_b"
                icona = 4
            Case "d_22_b"
                icona = 4
            Case "d_23_b"
                icona = 4
            Case "d_24_b"
                icona = 4
            Case "d_25_b"
                icona = 4
            Case "d_26_b"
                icona = 4
            Case "d_27_b"
                icona = 4
            Case "d_28_b"
                icona = 4
            Case "d_29_b"
                icona = 4

            Case "d_3_b"
                icona = 5
            Case "d_30_b"
                icona = 5
            Case "d_31_b"
                icona = 5
            Case "d_32_b"
                icona = 5
            Case "d_33_b"
                icona = 5
            Case "d_34_b"
                icona = 5
            Case "d_35_b"
                icona = 5
            Case "d_36_b"
                icona = 5
            Case "d_37_b"
                icona = 5
            Case "d_38_b"
                icona = 5
            Case "d_39_b"
                icona = 5

            Case "d_4_b"
                icona = 5
            Case "d_40_b"
                icona = 5
            Case "d_41_b"
                icona = 5
            Case "d_42_b"
                icona = 5
            Case "d_43_b"
                icona = 5
            Case "d_44_b"
                icona = 5
            Case "d_45_b"
                icona = 3
            Case "d_46_b"
                icona = 5
            Case "d_47_b"
                icona = 5
            Case "d_48_b"
                icona = 5
            Case "d_49_b"
                icona = 3

            Case "d_5_b"
                icona = 14
            Case "d_50_b"
                icona = 14
            Case "d_51_b"
                icona = 14
            Case "d_52_b"
                icona = 14
            Case "d_53_b"
                icona = 7
            Case "d_54_b"
                icona = 7
            Case "d_55_b"
                icona = 7
            Case "d_56_b"
                icona = 7
            Case "d_57_b"
                icona = 7
            Case "d_58_b"
                icona = 7
            Case "d_59_b"
                icona = 7

            Case "d_6_b"
                icona = 7
            Case "d_60_b"
                icona = 14
            Case "d_61_b"
                icona = 14
            Case "d_62_b"
                icona = 14
            Case "d_63_b"
                icona = 7
            Case "d_64_b"
                icona = 8
            Case "d_65_b"
                icona = 8
            Case "d_66_b"
                icona = 9
            Case "d_67_b"
                icona = 8
            Case "d_68_b"
                icona = 9
            Case "d_69_b"
                icona = 8

            Case "d_7_b"
                icona = 11
            Case "d_70_b"
                icona = 10
            Case "d_71_b"
                icona = 10
            Case "d_72_b"
                icona = 11
            Case "d_73_b"
                icona = 10
            Case "d_74_b"
                icona = 11
            Case "d_75_b"
                icona = 11
            Case "d_76_b"
                icona = 11
            Case "d_77_b"
                icona = 11
            Case "d_78_b"
                icona = 11
            Case "d_79_b"
                icona = 11

            Case "d_8_b"
                icona = 8
            Case "d_80_b"
                icona = 14
            Case "d_81_b"
                icona = 14
            Case "d_82_b"
                icona = 7
            Case "d_83_b"
                icona = 7
            Case "d_84_b"
                icona = 9
            Case "d_85_b"
                icona = 10
            Case "d_86_b"
                icona = 14
            Case "d_87_b"
                icona = 14
            Case "d_88_b"
                icona = 14
            Case "d_89_b"
                icona = 14

            Case "d_9_b"
                icona = 13
            Case "d_90_b"
                icona = 13
            Case "d_91_b"
                icona = 13
            Case "d_92_b"
                icona = 13
            Case "d_93_b"
                icona = 13
            Case "d_94_b"
                icona = 13
            Case "d_95_b"
                icona = 15
            Case "d_96_b"
                icona = 13
            Case "d_97_b"
                icona = 13
            Case "d_98_b"
                icona = 13
            Case "d_99_b"
                icona = 13

            Case "n_0_b"
                icona = 17

            Case "n_1_b"
                icona = 18
            Case "n_10_b"
                icona = 23
            Case "n_11_b"
                icona = 18
            Case "n_12_b"
                icona = 18
            Case "n_13_b"
                icona = 18
            Case "n_14_b"
                icona = 18
            Case "n_15_b"
                icona = 18
            Case "n_16_b"
                icona = 18
            Case "n_17_b"
                icona = 18
            Case "n_18_b"
                icona = 18
            Case "n_19_b"
                icona = 18

            Case "n_2_b"
                icona = 18
            Case "n_20_b"
                icona = 18
            Case "n_21_b"
                icona = 18
            Case "n_22_b"
                icona = 18
            Case "n_23_b"
                icona = 18
            Case "n_24_b"
                icona = 18
            Case "n_25_b"
                icona = 18
            Case "n_26_b"
                icona = 18
            Case "n_27_b"
                icona = 18
            Case "n_28_b"
                icona = 18
            Case "n_29_b"
                icona = 18

            Case "n_3_b"
                icona = 19
            Case "n_30_b"
                icona = 19
            Case "n_31_b"
                icona = 19
            Case "n_32_b"
                icona = 19
            Case "n_33_b"
                icona = 19
            Case "n_34_b"
                icona = 19
            Case "n_35_b"
                icona = 19
            Case "n_36_b"
                icona = 19
            Case "n_37_b"
                icona = 19
            Case "n_38_b"
                icona = 19
            Case "n_39_b"
                icona = 19

            Case "n_4_b"
                icona = 20  ' eigentlich Nebel
            Case "n_40_b"
                icona = 20
            Case "n_41_b"
                icona = 20
            Case "n_42_b"
                icona = 20
            Case "n_43_b"
                icona = 20
            Case "n_44_b"
                icona = 20
            Case "n_45_b"
                icona = 18
            Case "n_46_b"
                icona = 20
            Case "n_47_b"
                icona = 20
            Case "n_48_b"
                icona = 20
            Case "n_49_b"
                icona = 18

            Case "n_5_b"
                icona = 28
            Case "n_50_b"
                icona = 28
            Case "n_51_b"
                icona = 28
            Case "n_52_b"
                icona = 28
            Case "n_53_b"
                icona = 21
            Case "n_54_b"
                icona = 21
            Case "n_55_b"
                icona = 21
            Case "n_56_b"
                icona = 21
            Case "n_57_b"
                icona = 21
            Case "n_58_b"
                icona = 21
            Case "n_59_b"
                icona = 21

            Case "n_6_b"
                icona = 21
            Case "n_60_b"
                icona = 28
            Case "n_61_b"
                icona = 28
            Case "n_62_b"
                icona = 28
            Case "n_63_b"
                icona = 21
            Case "n_64_b"
                icona = 22
            Case "n_65_b"
                icona = 22
            Case "n_66_b"
                icona = 23
            Case "n_67_b"
                icona = 22
            Case "n_68_b"
                icona = 23
            Case "n_69_b"
                icona = 22

            Case "n_7_b"
                icona = 25
            Case "n_70_b"
                icona = 24
            Case "n_71_b"
                icona = 24
            Case "n_72_b"
                icona = 24
            Case "n_73_b"
                icona = 24
            Case "n_74_b"
                icona = 25
            Case "n_75_b"
                icona = 25
            Case "n_76_b"
                icona = 25
            Case "n_77_b"
                icona = 25
            Case "n_78_b"
                icona = 25
            Case "n_79_b"
                icona = 25

            Case "n_8_b"
                icona = 22
            Case "n_80_b"
                icona = 28
            Case "n_81_b"
                icona = 28
            Case "n_82_b"
                icona = 21
            Case "n_83_b"
                icona = 21
            Case "n_84_b"
                icona = 24
            Case "n_85_b"
                icona = 23
            Case "n_86_b"
                icona = 23
            Case "n_87_b"
                icona = 23
            Case "n_88_b"
                icona = 23
            Case "n_89_b"
                icona = 23

            Case "n_9_b"
                icona = 27
            Case "n_90_b"
                icona = 27
            Case "n_91_b"
                icona = 27
            Case "n_92_b"
                icona = 27
            Case "n_93_b"
                icona = 27
            Case "n_94_b"
                icona = 27
            Case "n_95_b"
                icona = 29
            Case "n_96_b"
                icona = 27
            Case "n_97_b"
                icona = 27
            Case "n_98_b"
                icona = 27
            Case "n_99_b"
                icona = 27
        End Select


        posicio = InStr(s, "Min / Max")
        s = Mid(s, posicio + 110) 'abans era 170

        'posicio = InStr(s, "&gt;")
        's = Mid(s, posicio + 4)
        talla(s, Chr(34) & ">")


        posicio = InStr(s, "/")

        temperatura1 = Mid(s, 1, posicio - 1)

        s = Mid(s, posicio + 1)
        posicio = InStr(s, "&")
        temperatura2 = Mid(s, 1, posicio - 1)

        value = "S|" & Trim(icona) & "|" & Trim(temperatura1) & "|" & Trim(temperatura2)

        'REGISTRE DE WINDOWS:

        ' Llegir:
        'Dim readValue As String
        'readValue = My.Computer.Registry.GetValue _
        '("HKEY_CURRENT_USER\Software\MyApp", "Name", Nothing)
        'MsgBox("The value is " & readValue)


        'Escriure:
        'Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\TestApp", "Name", "Author's Name")


        'Registry.SetValue(keyName, valueName, value)
        Registry.SetValue(registerKey1, registerKey2, value)
        Registry.SetValue(registerKey1, registerKey2Userdata, registerKey2UserdataValue)

    End Sub


    Private Sub updateWeatherHTCfromInternetAccuweather()
        If URLaccuweather = "" Then Exit Sub

        'Dim myXmlDoc As XmlDocument
        'myXmlDoc.
        Dim s As String = ""

        Dim ciutat As String = AccuWeatherCity
        If AccuWeatherCity = "" Then
            ciutat = Registry.GetValue(HTCregisterKey1 & "\Settings", "LocationCode", Nothing)
            If ciutat = Nothing Then MsgBox("ERROR: City not found in HTC!")
        End If
        'descarregar("http://htc.accuweather.com/widget/htc/forecast-data_v3.asp?ac=TR2cra9U&locCode=EUR|DE|GM007|DARMSTADT", "/accuweather.xml")
        descarregar(URLaccuweather & ciutat, FILEaccuweather)

        Try
            ' Open the file to read from.
            Dim sr As System.IO.StreamReader = System.IO.File.OpenText(FILEaccuweather)

            s = sr.ReadToEnd()
            sr.Close()

        Catch ex As Exception
            Beep()
            MsgBox("Error: I cannot load the file " & FILEaccuweather)

        End Try




        'Dim localTime As String = valorEntreFragments(s, "<localTime>", "</localTime>")
        'Dim localTimeDate As Date = Date.Parse(localTime)
        Dim localTimeDate As Date = Now

        'Dim windSpeed As String = valorEntreFragments(s, "kph=" & Chr(34), Chr(34) & " mph=")
        'Dim windDirection As String = valorEntreFragments(s, "<winddir direction=" & Chr(34), "</winddir>")
        'windDirection = Left(windDirection, InStr(windDirection, Chr(34) & ">") - 1)



        'EL CAMP Location JA ESCRIC DES DE updateWeatherHTCfromInternetWettercom():
        'Registry.SetValue(HTCregisterKey1 & "\Settings", "Location", localTimeDate.Hour.ToString & ":" & localTimeDate.Minute.ToString & " " & localTimeDate.Day.ToString & "." & localTimeDate.Month.ToString & " (" & windSpeed & " km/h " & windDirection & ")")
        Registry.SetValue(HTCregisterKey1, "LastUpdateMMeteo", Left(localTimeDate.TimeOfDay.ToString, 5) & " " & Left(localTimeDate.Date.ToString, 5))





        talla(s, "<current>")
        Registry.SetValue(HTCregisterKey1, "CurrentTemp", Val(valorEntreFragments(s, "f=" & Chr(34), Chr(34) & "/>")))


        talla(s, "<condition")
        Registry.SetValue(HTCregisterKey1, "Icon", Val(valorEntreFragments(s, "icon=" & Chr(34), Chr(34) & ">")))

        Dim i As Short

        For i = 1 To 5 'els 5 dies de previsi
            talla(s, "<day number=" & Chr(34) & i & Chr(34) & ">")
            Registry.SetValue(HTCregisterKey1 & "\Forecast" & (i - 1), "DayCode", valorEntreFragments(s, "<name>", "</name>"))
            talla(s, "<condition")
            Registry.SetValue(HTCregisterKey1 & "\Forecast" & (i - 1), "Icon", Val(valorEntreFragments(s, "icon=" & Chr(34), Chr(34) & ">")))
            talla(s, "<high")
            Registry.SetValue(HTCregisterKey1 & "\Forecast" & (i - 1), "HighTemp", Val(valorEntreFragments(s, "f=" & Chr(34), Chr(34) & " />")))
            talla(s, "<low")
            Registry.SetValue(HTCregisterKey1 & "\Forecast" & (i - 1), "LowTemp", Val(valorEntreFragments(s, "f=" & Chr(34), Chr(34) & " />")))
        Next



        'actualitza data ultima sincronitzaci amb exit
        ' Dim lastUpdateAction = Registry.GetValue(HTCregisterKey1, "LastUpdateAction", Nothing)
        'If lastUpdateAction <> Nothing Then


        'Try
        '    Registry.SetValue(HTCregisterKey1, "LastUpdate", Registry.GetValue(HTCregisterKey1, "LastUpdateAction", Nothing))
        'Catch
        '    MsgBox("Error: Problema al llegir LastUpdateAction i copiar-lo a LastUpdate")
        'End Try

        Registry.SetValue(HTCregisterKey1, "Status", 2)


    End Sub

    Private Sub updateWeatherHTCfromInternetWettercom()
        If URLwettercomFiltered <> "" Then URLwettercom = URLwettercomFiltered

        If URLwettercom = "" Then Exit Sub

        descarregar(URLwettercom, FILEwettercom)
        'updateWeatherHTCfromFileWettercom()  's'executa ms tard

    End Sub
    Private Sub updateWeatherHTCfromFileWettercom(ByRef s As String, Optional ByVal prediccioWetter As String = "")

        If s = "" Then MsgBox("Error: File is empty " & FILEwettercom)


        'Registry.SetValue(HTCregisterKey1 & "\Settings", "Location", Trim(valorEntreFragments(s, "<title>", "|")))

        If prediccioWetter = "" Then
            prediccioWetter = Trim(valorEntreFragments(s, "<title>", "|")) & "|"
        End If

        If (Now.Hour >= nightStart) Then
            talla(prediccioWetter, " ")
            prediccioWetter = Trim(valorEntreFragments(prediccioWetter, " ", "|"))
        ElseIf (Now.Hour >= middayStart) Then
            prediccioWetter = Trim(valorEntreFragments(prediccioWetter, " ", "|"))
        End If

        Registry.SetValue(HTCregisterKey1 & "\Settings", "Location", Trim(prediccioWetter) & " " & Left(Registry.GetValue(HTCregisterKey1, "LastUpdateMMeteo", Nothing), 5))


    End Sub




    Sub Main(ByVal Arguments As String())


        'Const POWER_STATE_ON As Integer = &H10000
        'Const POWER_STATE_OFF As Integer = &H20000
        'Const POWER_STATE_SUSPEND As Integer = &H200000

        'Const POWER_FORCE As Integer = 4096
        'SetSystemPowerState(Nothing, POWER_STATE_ON, POWER_FORCE)

        loadGlobals()

        If Arguments.Length > 0 Then ' si automaticament engegada el unic parametre rebut es Trim(Arguments.GetValue(0)) = "AppRunAtTime" Then

            If Trim(Arguments.GetValue(0)) = "/deactivate" Then
                SetAppStartSelfDelete()
            Else
                If Now.Hour = updateTime Then
                    'Noms s'executa pel demat

                    updateWeatherHTCfromInternetAccuweather()
                    updateWeatherHTCfromInternetWettercom()
                    updateWeatherAllFromFileWettercom()

                    SetAppStartProg()
                    SetAppStartSelf()

                    If (URLephemeris <> "") And (FILEephemeris <> "") And EphemerisDaysToWait > 0 Then
                        If ((Now.DayOfYear Mod EphemerisDaysToWait) = 0) Then 'noms un cop cada "EphemeridsDaysToWait" dies (les ephemerides duren 3 dies)
                            'Actualitza QuickGPS:
                            descarregar(URLephemeris, FILEephemeris)
                        End If
                    End If
                End If
            End If
        Else
            'Noms s'executa al engegar el programa manualment
            updateWeatherHTCfromInternetAccuweather()
            updateWeatherHTCfromInternetWettercom()
            updateWeatherAllFromFileWettercom()

            SetAppStartProg()
            SetAppStartSelf()

            'Actualitza QuickGPS:
            descarregar(URLephemeris, FILEephemeris)
        End If

        's'executa 3 cops al dia:

        updateWeatherAllFromFileWettercom()
    End Sub


End Module
